# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class CardProcessingConfigFeaturesCardPresent(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'processors': 'dict(str, CardProcessingConfigFeaturesCardPresentProcessors)',
        'enable_terminal_id_lookup': 'bool'
    }

    attribute_map = {
        'processors': 'processors',
        'enable_terminal_id_lookup': 'enableTerminalIdLookup'
    }

    def __init__(self, processors=None, enable_terminal_id_lookup=None):
        """
        CardProcessingConfigFeaturesCardPresent - a model defined in Swagger
        """

        self._processors = None
        self._enable_terminal_id_lookup = None

        if processors is not None:
          self.processors = processors
        if enable_terminal_id_lookup is not None:
          self.enable_terminal_id_lookup = enable_terminal_id_lookup

    @property
    def processors(self):
        """
        Gets the processors of this CardProcessingConfigFeaturesCardPresent.
        e.g. * amexdirect * barclays2 * CUP * EFTPOS * fdiglobal * gpx * smartfdc * tsys * vero * VPC  For VPC, CUP and EFTPOS processors, replace the processor name from VPC or CUP or EFTPOS to the actual processor name in the sample request. e.g. replace VPC with &lt;your vpc processor&gt; 

        :return: The processors of this CardProcessingConfigFeaturesCardPresent.
        :rtype: dict(str, CardProcessingConfigFeaturesCardPresentProcessors)
        """
        return self._processors

    @processors.setter
    def processors(self, processors):
        """
        Sets the processors of this CardProcessingConfigFeaturesCardPresent.
        e.g. * amexdirect * barclays2 * CUP * EFTPOS * fdiglobal * gpx * smartfdc * tsys * vero * VPC  For VPC, CUP and EFTPOS processors, replace the processor name from VPC or CUP or EFTPOS to the actual processor name in the sample request. e.g. replace VPC with &lt;your vpc processor&gt; 

        :param processors: The processors of this CardProcessingConfigFeaturesCardPresent.
        :type: dict(str, CardProcessingConfigFeaturesCardPresentProcessors)
        """

        self._processors = processors

    @property
    def enable_terminal_id_lookup(self):
        """
        Gets the enable_terminal_id_lookup of this CardProcessingConfigFeaturesCardPresent.
        Used for Card Present and Virtual Terminal Transactions for Terminal ID lookup. Applicable for GPX (gpx) processor.

        :return: The enable_terminal_id_lookup of this CardProcessingConfigFeaturesCardPresent.
        :rtype: bool
        """
        return self._enable_terminal_id_lookup

    @enable_terminal_id_lookup.setter
    def enable_terminal_id_lookup(self, enable_terminal_id_lookup):
        """
        Sets the enable_terminal_id_lookup of this CardProcessingConfigFeaturesCardPresent.
        Used for Card Present and Virtual Terminal Transactions for Terminal ID lookup. Applicable for GPX (gpx) processor.

        :param enable_terminal_id_lookup: The enable_terminal_id_lookup of this CardProcessingConfigFeaturesCardPresent.
        :type: bool
        """

        self._enable_terminal_id_lookup = enable_terminal_id_lookup

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CardProcessingConfigFeaturesCardPresent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
