# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class PtsV2PaymentsCapturesPost201ResponseProcessorInformation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'transaction_id': 'str',
        'network_transaction_id': 'str',
        'response_details': 'str',
        'response_code': 'str',
        'provider_response': 'str'
    }

    attribute_map = {
        'transaction_id': 'transactionId',
        'network_transaction_id': 'networkTransactionId',
        'response_details': 'responseDetails',
        'response_code': 'responseCode',
        'provider_response': 'providerResponse'
    }

    def __init__(self, transaction_id=None, network_transaction_id=None, response_details=None, response_code=None, provider_response=None):
        """
        PtsV2PaymentsCapturesPost201ResponseProcessorInformation - a model defined in Swagger
        """

        self._transaction_id = None
        self._network_transaction_id = None
        self._response_details = None
        self._response_code = None
        self._provider_response = None

        if transaction_id is not None:
          self.transaction_id = transaction_id
        if network_transaction_id is not None:
          self.network_transaction_id = network_transaction_id
        if response_details is not None:
          self.response_details = response_details
        if response_code is not None:
          self.response_code = response_code
        if provider_response is not None:
          self.provider_response = provider_response

    @property
    def transaction_id(self):
        """
        Gets the transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        Processor transaction ID.  This value identifies the transaction on a host system. This value is supported only for Moneris. It contains this information:   - Terminal used to process the transaction  - Shift during which the transaction took place  - Batch number  - Transaction number within the batch  You must store this value. If you give the customer a receipt, display this value on the receipt.  Example For the value 66012345001069003:   - Terminal ID = 66012345  - Shift number = 001  - Batch number = 069  - Transaction number = 003 

        :return: The transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :rtype: str
        """
        return self._transaction_id

    @transaction_id.setter
    def transaction_id(self, transaction_id):
        """
        Sets the transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        Processor transaction ID.  This value identifies the transaction on a host system. This value is supported only for Moneris. It contains this information:   - Terminal used to process the transaction  - Shift during which the transaction took place  - Batch number  - Transaction number within the batch  You must store this value. If you give the customer a receipt, display this value on the receipt.  Example For the value 66012345001069003:   - Terminal ID = 66012345  - Shift number = 001  - Batch number = 069  - Transaction number = 003 

        :param transaction_id: The transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :type: str
        """

        self._transaction_id = transaction_id

    @property
    def network_transaction_id(self):
        """
        Gets the network_transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        Network Transaction Identifier Applicable for online capture transactions only. 

        :return: The network_transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :rtype: str
        """
        return self._network_transaction_id

    @network_transaction_id.setter
    def network_transaction_id(self, network_transaction_id):
        """
        Sets the network_transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        Network Transaction Identifier Applicable for online capture transactions only. 

        :param network_transaction_id: The network_transaction_id of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :type: str
        """

        self._network_transaction_id = network_transaction_id

    @property
    def response_details(self):
        """
        Gets the response_details of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        The processor code that describes why the transaction state is pending or reversed. 

        :return: The response_details of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :rtype: str
        """
        return self._response_details

    @response_details.setter
    def response_details(self, response_details):
        """
        Sets the response_details of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        The processor code that describes why the transaction state is pending or reversed. 

        :param response_details: The response_details of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :type: str
        """

        self._response_details = response_details

    @property
    def response_code(self):
        """
        Gets the response_code of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        For most processors, this is the error message sent directly from the bank. Returned only when the processor returns this value.  **Important** Do not use this field to evaluate the result of the authorization.  #### PIN debit Response value that is returned by the processor or bank. **Important** Do not use this field to evaluate the results of the transaction request.  Returned by PIN debit credit, PIN debit purchase, and PIN debit reversal.  #### AIBMS If this value is `08`, you can accept the transaction if the customer provides you with identification.  #### Atos This value is the response code sent from Atos and it might also include the response code from the bank. Format: `aa,bb` with the two values separated by a comma and where: - `aa` is the two-digit error message from Atos. - `bb` is the optional two-digit error message from the bank.  #### Comercio Latino This value is the status code and the error or response code received from the processor separated by a colon. Format: [status code]:E[error code] or [status code]:R[response code] Example `2:R06`  #### JCN Gateway Processor-defined detail error code. The associated response category code is in the `processorInformation.responseCategoryCode` field. String (3) 

        :return: The response_code of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :rtype: str
        """
        return self._response_code

    @response_code.setter
    def response_code(self, response_code):
        """
        Sets the response_code of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        For most processors, this is the error message sent directly from the bank. Returned only when the processor returns this value.  **Important** Do not use this field to evaluate the result of the authorization.  #### PIN debit Response value that is returned by the processor or bank. **Important** Do not use this field to evaluate the results of the transaction request.  Returned by PIN debit credit, PIN debit purchase, and PIN debit reversal.  #### AIBMS If this value is `08`, you can accept the transaction if the customer provides you with identification.  #### Atos This value is the response code sent from Atos and it might also include the response code from the bank. Format: `aa,bb` with the two values separated by a comma and where: - `aa` is the two-digit error message from Atos. - `bb` is the optional two-digit error message from the bank.  #### Comercio Latino This value is the status code and the error or response code received from the processor separated by a colon. Format: [status code]:E[error code] or [status code]:R[response code] Example `2:R06`  #### JCN Gateway Processor-defined detail error code. The associated response category code is in the `processorInformation.responseCategoryCode` field. String (3) 

        :param response_code: The response_code of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :type: str
        """

        self._response_code = response_code

    @property
    def provider_response(self):
        """
        Gets the provider_response of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        Processor response to the API request. 

        :return: The provider_response of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :rtype: str
        """
        return self._provider_response

    @provider_response.setter
    def provider_response(self, provider_response):
        """
        Sets the provider_response of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        Processor response to the API request. 

        :param provider_response: The provider_response of this PtsV2PaymentsCapturesPost201ResponseProcessorInformation.
        :type: str
        """

        self._provider_response = provider_response

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PtsV2PaymentsCapturesPost201ResponseProcessorInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
