# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class PtsV2PaymentsPost201Response2ProcessorInformation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'transaction_id': 'str',
        'payment_url': 'str',
        'response_details': 'str',
        'token': 'str',
        'response_code': 'str'
    }

    attribute_map = {
        'transaction_id': 'transactionId',
        'payment_url': 'paymentUrl',
        'response_details': 'responseDetails',
        'token': 'token',
        'response_code': 'responseCode'
    }

    def __init__(self, transaction_id=None, payment_url=None, response_details=None, token=None, response_code=None):
        """
        PtsV2PaymentsPost201Response2ProcessorInformation - a model defined in Swagger
        """

        self._transaction_id = None
        self._payment_url = None
        self._response_details = None
        self._token = None
        self._response_code = None

        if transaction_id is not None:
          self.transaction_id = transaction_id
        if payment_url is not None:
          self.payment_url = payment_url
        if response_details is not None:
          self.response_details = response_details
        if token is not None:
          self.token = token
        if response_code is not None:
          self.response_code = response_code

    @property
    def transaction_id(self):
        """
        Gets the transaction_id of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Network transaction identifier (TID). You can use this value to identify a specific transaction when you are discussing the transaction with your processor. Not all processors provide this value.  Returned by the authorization service.  #### PIN debit Transaction identifier generated by the processor.  Returned by PIN debit credit.  #### GPX Processor transaction ID.  #### Cielo For Cielo, this value is the non-sequential unit (NSU) and is supported for all transactions. The value is generated by Cielo or the issuing bank.  #### Comercio Latino For Comercio Latino, this value is the proof of sale or non-sequential unit (NSU) number generated by the acquirers Cielo and Rede, or the issuing bank.  #### CyberSource through VisaNet and GPN For details about this value for CyberSource through VisaNet and GPN, see \"Network Transaction Identifiers\" in [Credit Card Services Using the SCMP API.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/)  #### Moneris This value identifies the transaction on a host system. It contains the following information: - Terminal used to process the transaction - Shift during which the transaction took place - Batch number - Transaction number within the batch You must store this value. If you give the customer a receipt, display this value on the receipt.  **Example** For the value 66012345001069003: - Terminal ID = 66012345 - Shift number = 001 - Batch number = 069 - Transaction number = 003 

        :return: The transaction_id of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :rtype: str
        """
        return self._transaction_id

    @transaction_id.setter
    def transaction_id(self, transaction_id):
        """
        Sets the transaction_id of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Network transaction identifier (TID). You can use this value to identify a specific transaction when you are discussing the transaction with your processor. Not all processors provide this value.  Returned by the authorization service.  #### PIN debit Transaction identifier generated by the processor.  Returned by PIN debit credit.  #### GPX Processor transaction ID.  #### Cielo For Cielo, this value is the non-sequential unit (NSU) and is supported for all transactions. The value is generated by Cielo or the issuing bank.  #### Comercio Latino For Comercio Latino, this value is the proof of sale or non-sequential unit (NSU) number generated by the acquirers Cielo and Rede, or the issuing bank.  #### CyberSource through VisaNet and GPN For details about this value for CyberSource through VisaNet and GPN, see \"Network Transaction Identifiers\" in [Credit Card Services Using the SCMP API.](https://apps.cybersource.com/library/documentation/dev_guides/CC_Svcs_SCMP_API/html/)  #### Moneris This value identifies the transaction on a host system. It contains the following information: - Terminal used to process the transaction - Shift during which the transaction took place - Batch number - Transaction number within the batch You must store this value. If you give the customer a receipt, display this value on the receipt.  **Example** For the value 66012345001069003: - Terminal ID = 66012345 - Shift number = 001 - Batch number = 069 - Transaction number = 003 

        :param transaction_id: The transaction_id of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :type: str
        """

        self._transaction_id = transaction_id

    @property
    def payment_url(self):
        """
        Gets the payment_url of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Direct the customer to this URL to complete the payment.

        :return: The payment_url of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :rtype: str
        """
        return self._payment_url

    @payment_url.setter
    def payment_url(self, payment_url):
        """
        Sets the payment_url of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Direct the customer to this URL to complete the payment.

        :param payment_url: The payment_url of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :type: str
        """

        self._payment_url = payment_url

    @property
    def response_details(self):
        """
        Gets the response_details of this PtsV2PaymentsPost201Response2ProcessorInformation.
        This field might contain information about a decline. This field is supported only for **CyberSource through VisaNet**. 

        :return: The response_details of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :rtype: str
        """
        return self._response_details

    @response_details.setter
    def response_details(self, response_details):
        """
        Sets the response_details of this PtsV2PaymentsPost201Response2ProcessorInformation.
        This field might contain information about a decline. This field is supported only for **CyberSource through VisaNet**. 

        :param response_details: The response_details of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :type: str
        """

        self._response_details = response_details

    @property
    def token(self):
        """
        Gets the token of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Payment gateway/processor assigned session token. 

        :return: The token of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token):
        """
        Sets the token of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Payment gateway/processor assigned session token. 

        :param token: The token of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :type: str
        """

        self._token = token

    @property
    def response_code(self):
        """
        Gets the response_code of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Transaction status from the processor. 

        :return: The response_code of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :rtype: str
        """
        return self._response_code

    @response_code.setter
    def response_code(self, response_code):
        """
        Sets the response_code of this PtsV2PaymentsPost201Response2ProcessorInformation.
        Transaction status from the processor. 

        :param response_code: The response_code of this PtsV2PaymentsPost201Response2ProcessorInformation.
        :type: str
        """

        self._response_code = response_code

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PtsV2PaymentsPost201Response2ProcessorInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
