# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class Riskv1decisionsOrderInformation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'amount_details': 'Riskv1decisionsOrderInformationAmountDetails',
        'pre_order': 'str',
        'pre_order_date': 'str',
        'cutoff_date_time': 'str',
        'reordered': 'bool',
        'shipping_details': 'Riskv1decisionsOrderInformationShippingDetails',
        'ship_to': 'Riskv1decisionsOrderInformationShipTo',
        'returns_accepted': 'bool',
        'line_items': 'list[Riskv1decisionsOrderInformationLineItems]',
        'bill_to': 'Riskv1decisionsOrderInformationBillTo',
        'total_offers_count': 'str'
    }

    attribute_map = {
        'amount_details': 'amountDetails',
        'pre_order': 'preOrder',
        'pre_order_date': 'preOrderDate',
        'cutoff_date_time': 'cutoffDateTime',
        'reordered': 'reordered',
        'shipping_details': 'shippingDetails',
        'ship_to': 'shipTo',
        'returns_accepted': 'returnsAccepted',
        'line_items': 'lineItems',
        'bill_to': 'billTo',
        'total_offers_count': 'totalOffersCount'
    }

    def __init__(self, amount_details=None, pre_order=None, pre_order_date=None, cutoff_date_time=None, reordered=None, shipping_details=None, ship_to=None, returns_accepted=None, line_items=None, bill_to=None, total_offers_count=None):
        """
        Riskv1decisionsOrderInformation - a model defined in Swagger
        """

        self._amount_details = None
        self._pre_order = None
        self._pre_order_date = None
        self._cutoff_date_time = None
        self._reordered = None
        self._shipping_details = None
        self._ship_to = None
        self._returns_accepted = None
        self._line_items = None
        self._bill_to = None
        self._total_offers_count = None

        if amount_details is not None:
          self.amount_details = amount_details
        if pre_order is not None:
          self.pre_order = pre_order
        if pre_order_date is not None:
          self.pre_order_date = pre_order_date
        if cutoff_date_time is not None:
          self.cutoff_date_time = cutoff_date_time
        if reordered is not None:
          self.reordered = reordered
        if shipping_details is not None:
          self.shipping_details = shipping_details
        if ship_to is not None:
          self.ship_to = ship_to
        if returns_accepted is not None:
          self.returns_accepted = returns_accepted
        if line_items is not None:
          self.line_items = line_items
        if bill_to is not None:
          self.bill_to = bill_to
        if total_offers_count is not None:
          self.total_offers_count = total_offers_count

    @property
    def amount_details(self):
        """
        Gets the amount_details of this Riskv1decisionsOrderInformation.

        :return: The amount_details of this Riskv1decisionsOrderInformation.
        :rtype: Riskv1decisionsOrderInformationAmountDetails
        """
        return self._amount_details

    @amount_details.setter
    def amount_details(self, amount_details):
        """
        Sets the amount_details of this Riskv1decisionsOrderInformation.

        :param amount_details: The amount_details of this Riskv1decisionsOrderInformation.
        :type: Riskv1decisionsOrderInformationAmountDetails
        """

        self._amount_details = amount_details

    @property
    def pre_order(self):
        """
        Gets the pre_order of this Riskv1decisionsOrderInformation.
        Indicates whether cardholder is placing an order with a future availability or release date. This field can contain one of these values: - MERCHANDISE_AVAILABLE: Merchandise available - FUTURE_AVAILABILITY: Future availability 

        :return: The pre_order of this Riskv1decisionsOrderInformation.
        :rtype: str
        """
        return self._pre_order

    @pre_order.setter
    def pre_order(self, pre_order):
        """
        Sets the pre_order of this Riskv1decisionsOrderInformation.
        Indicates whether cardholder is placing an order with a future availability or release date. This field can contain one of these values: - MERCHANDISE_AVAILABLE: Merchandise available - FUTURE_AVAILABILITY: Future availability 

        :param pre_order: The pre_order of this Riskv1decisionsOrderInformation.
        :type: str
        """

        self._pre_order = pre_order

    @property
    def pre_order_date(self):
        """
        Gets the pre_order_date of this Riskv1decisionsOrderInformation.
        Expected date that a pre-ordered purchase will be available. Format: YYYYMMDD 

        :return: The pre_order_date of this Riskv1decisionsOrderInformation.
        :rtype: str
        """
        return self._pre_order_date

    @pre_order_date.setter
    def pre_order_date(self, pre_order_date):
        """
        Sets the pre_order_date of this Riskv1decisionsOrderInformation.
        Expected date that a pre-ordered purchase will be available. Format: YYYYMMDD 

        :param pre_order_date: The pre_order_date of this Riskv1decisionsOrderInformation.
        :type: str
        """

        self._pre_order_date = pre_order_date

    @property
    def cutoff_date_time(self):
        """
        Gets the cutoff_date_time of this Riskv1decisionsOrderInformation.
        Starting date and time for an event or a journey that is independent of which transportation mechanism, in UTC. The cutoffDateTime will supersede travelInformation.departureTime if both are supplied in the request. Format: YYYY-MM-DDThh:mm:ssZ. Example 2016-08-11T22:47:57Z equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). The T separates the date and the time. The Z indicates UTC. 

        :return: The cutoff_date_time of this Riskv1decisionsOrderInformation.
        :rtype: str
        """
        return self._cutoff_date_time

    @cutoff_date_time.setter
    def cutoff_date_time(self, cutoff_date_time):
        """
        Sets the cutoff_date_time of this Riskv1decisionsOrderInformation.
        Starting date and time for an event or a journey that is independent of which transportation mechanism, in UTC. The cutoffDateTime will supersede travelInformation.departureTime if both are supplied in the request. Format: YYYY-MM-DDThh:mm:ssZ. Example 2016-08-11T22:47:57Z equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). The T separates the date and the time. The Z indicates UTC. 

        :param cutoff_date_time: The cutoff_date_time of this Riskv1decisionsOrderInformation.
        :type: str
        """

        self._cutoff_date_time = cutoff_date_time

    @property
    def reordered(self):
        """
        Gets the reordered of this Riskv1decisionsOrderInformation.
        Indicates whether the cardholder is reordering previously purchased merchandise. This field can contain one of these values: - false: First time ordered - true: Reordered 

        :return: The reordered of this Riskv1decisionsOrderInformation.
        :rtype: bool
        """
        return self._reordered

    @reordered.setter
    def reordered(self, reordered):
        """
        Sets the reordered of this Riskv1decisionsOrderInformation.
        Indicates whether the cardholder is reordering previously purchased merchandise. This field can contain one of these values: - false: First time ordered - true: Reordered 

        :param reordered: The reordered of this Riskv1decisionsOrderInformation.
        :type: bool
        """

        self._reordered = reordered

    @property
    def shipping_details(self):
        """
        Gets the shipping_details of this Riskv1decisionsOrderInformation.

        :return: The shipping_details of this Riskv1decisionsOrderInformation.
        :rtype: Riskv1decisionsOrderInformationShippingDetails
        """
        return self._shipping_details

    @shipping_details.setter
    def shipping_details(self, shipping_details):
        """
        Sets the shipping_details of this Riskv1decisionsOrderInformation.

        :param shipping_details: The shipping_details of this Riskv1decisionsOrderInformation.
        :type: Riskv1decisionsOrderInformationShippingDetails
        """

        self._shipping_details = shipping_details

    @property
    def ship_to(self):
        """
        Gets the ship_to of this Riskv1decisionsOrderInformation.

        :return: The ship_to of this Riskv1decisionsOrderInformation.
        :rtype: Riskv1decisionsOrderInformationShipTo
        """
        return self._ship_to

    @ship_to.setter
    def ship_to(self, ship_to):
        """
        Sets the ship_to of this Riskv1decisionsOrderInformation.

        :param ship_to: The ship_to of this Riskv1decisionsOrderInformation.
        :type: Riskv1decisionsOrderInformationShipTo
        """

        self._ship_to = ship_to

    @property
    def returns_accepted(self):
        """
        Gets the returns_accepted of this Riskv1decisionsOrderInformation.
        Boolean that indicates whether returns are accepted for this order. This field can contain one of the following values: - true: Returns are accepted for this order. - false: Returns are not accepted for this order. 

        :return: The returns_accepted of this Riskv1decisionsOrderInformation.
        :rtype: bool
        """
        return self._returns_accepted

    @returns_accepted.setter
    def returns_accepted(self, returns_accepted):
        """
        Sets the returns_accepted of this Riskv1decisionsOrderInformation.
        Boolean that indicates whether returns are accepted for this order. This field can contain one of the following values: - true: Returns are accepted for this order. - false: Returns are not accepted for this order. 

        :param returns_accepted: The returns_accepted of this Riskv1decisionsOrderInformation.
        :type: bool
        """

        self._returns_accepted = returns_accepted

    @property
    def line_items(self):
        """
        Gets the line_items of this Riskv1decisionsOrderInformation.
        This array contains detailed information about individual products in the order.

        :return: The line_items of this Riskv1decisionsOrderInformation.
        :rtype: list[Riskv1decisionsOrderInformationLineItems]
        """
        return self._line_items

    @line_items.setter
    def line_items(self, line_items):
        """
        Sets the line_items of this Riskv1decisionsOrderInformation.
        This array contains detailed information about individual products in the order.

        :param line_items: The line_items of this Riskv1decisionsOrderInformation.
        :type: list[Riskv1decisionsOrderInformationLineItems]
        """

        self._line_items = line_items

    @property
    def bill_to(self):
        """
        Gets the bill_to of this Riskv1decisionsOrderInformation.

        :return: The bill_to of this Riskv1decisionsOrderInformation.
        :rtype: Riskv1decisionsOrderInformationBillTo
        """
        return self._bill_to

    @bill_to.setter
    def bill_to(self, bill_to):
        """
        Sets the bill_to of this Riskv1decisionsOrderInformation.

        :param bill_to: The bill_to of this Riskv1decisionsOrderInformation.
        :type: Riskv1decisionsOrderInformationBillTo
        """

        self._bill_to = bill_to

    @property
    def total_offers_count(self):
        """
        Gets the total_offers_count of this Riskv1decisionsOrderInformation.
        Total number of articles/items in the order as a numeric decimal count. Possible values: 00 - 99 

        :return: The total_offers_count of this Riskv1decisionsOrderInformation.
        :rtype: str
        """
        return self._total_offers_count

    @total_offers_count.setter
    def total_offers_count(self, total_offers_count):
        """
        Sets the total_offers_count of this Riskv1decisionsOrderInformation.
        Total number of articles/items in the order as a numeric decimal count. Possible values: 00 - 99 

        :param total_offers_count: The total_offers_count of this Riskv1decisionsOrderInformation.
        :type: str
        """

        self._total_offers_count = total_offers_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Riskv1decisionsOrderInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
