# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class Riskv1decisionsPaymentInformation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'card': 'Riskv1decisionsPaymentInformationCard',
        'tokenized_card': 'Riskv1decisionsPaymentInformationTokenizedCard',
        'customer': 'Ptsv2paymentsPaymentInformationCustomer',
        'bank': 'Ptsv2paymentsPaymentInformationBank',
        'method': 'str'
    }

    attribute_map = {
        'card': 'card',
        'tokenized_card': 'tokenizedCard',
        'customer': 'customer',
        'bank': 'bank',
        'method': 'method'
    }

    def __init__(self, card=None, tokenized_card=None, customer=None, bank=None, method=None):
        """
        Riskv1decisionsPaymentInformation - a model defined in Swagger
        """

        self._card = None
        self._tokenized_card = None
        self._customer = None
        self._bank = None
        self._method = None

        if card is not None:
          self.card = card
        if tokenized_card is not None:
          self.tokenized_card = tokenized_card
        if customer is not None:
          self.customer = customer
        if bank is not None:
          self.bank = bank
        if method is not None:
          self.method = method

    @property
    def card(self):
        """
        Gets the card of this Riskv1decisionsPaymentInformation.

        :return: The card of this Riskv1decisionsPaymentInformation.
        :rtype: Riskv1decisionsPaymentInformationCard
        """
        return self._card

    @card.setter
    def card(self, card):
        """
        Sets the card of this Riskv1decisionsPaymentInformation.

        :param card: The card of this Riskv1decisionsPaymentInformation.
        :type: Riskv1decisionsPaymentInformationCard
        """

        self._card = card

    @property
    def tokenized_card(self):
        """
        Gets the tokenized_card of this Riskv1decisionsPaymentInformation.

        :return: The tokenized_card of this Riskv1decisionsPaymentInformation.
        :rtype: Riskv1decisionsPaymentInformationTokenizedCard
        """
        return self._tokenized_card

    @tokenized_card.setter
    def tokenized_card(self, tokenized_card):
        """
        Sets the tokenized_card of this Riskv1decisionsPaymentInformation.

        :param tokenized_card: The tokenized_card of this Riskv1decisionsPaymentInformation.
        :type: Riskv1decisionsPaymentInformationTokenizedCard
        """

        self._tokenized_card = tokenized_card

    @property
    def customer(self):
        """
        Gets the customer of this Riskv1decisionsPaymentInformation.

        :return: The customer of this Riskv1decisionsPaymentInformation.
        :rtype: Ptsv2paymentsPaymentInformationCustomer
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """
        Sets the customer of this Riskv1decisionsPaymentInformation.

        :param customer: The customer of this Riskv1decisionsPaymentInformation.
        :type: Ptsv2paymentsPaymentInformationCustomer
        """

        self._customer = customer

    @property
    def bank(self):
        """
        Gets the bank of this Riskv1decisionsPaymentInformation.

        :return: The bank of this Riskv1decisionsPaymentInformation.
        :rtype: Ptsv2paymentsPaymentInformationBank
        """
        return self._bank

    @bank.setter
    def bank(self, bank):
        """
        Sets the bank of this Riskv1decisionsPaymentInformation.

        :param bank: The bank of this Riskv1decisionsPaymentInformation.
        :type: Ptsv2paymentsPaymentInformationBank
        """

        self._bank = bank

    @property
    def method(self):
        """
        Gets the method of this Riskv1decisionsPaymentInformation.
        Method of payment used for the order. This field can contain one of the following values:   - `consumer` (default): Customer credit card   - `corporate`: Corporate credit card   - `debit`: Debit card, such as a Maestro (UK Domestic) card   - `cod`: Collect on delivery   - `check`: Electronic check   - `p2p`: Person-to-person payment   - `private1`: Private label credit card   - `other`: Other payment method 

        :return: The method of this Riskv1decisionsPaymentInformation.
        :rtype: str
        """
        return self._method

    @method.setter
    def method(self, method):
        """
        Sets the method of this Riskv1decisionsPaymentInformation.
        Method of payment used for the order. This field can contain one of the following values:   - `consumer` (default): Customer credit card   - `corporate`: Corporate credit card   - `debit`: Debit card, such as a Maestro (UK Domestic) card   - `cod`: Collect on delivery   - `check`: Electronic check   - `p2p`: Person-to-person payment   - `private1`: Private label credit card   - `other`: Other payment method 

        :param method: The method of this Riskv1decisionsPaymentInformation.
        :type: str
        """

        self._method = method

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Riskv1decisionsPaymentInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
