# coding: utf-8

"""
    CyberSource Merged Spec

    All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html

    OpenAPI spec version: 0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from pprint import pformat
from six import iteritems
import re


class VasV2PaymentsPost201ResponseOrderInformation(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'exempt_amount': 'str',
        'taxable_amount': 'str',
        'tax_amount': 'str',
        'line_items': 'list[VasV2PaymentsPost201ResponseOrderInformationLineItems]',
        'tax_details': 'list[VasV2PaymentsPost201ResponseOrderInformationTaxDetails]',
        'amount_details': 'Ptsv2paymentsidreversalsReversalInformationAmountDetails'
    }

    attribute_map = {
        'exempt_amount': 'exemptAmount',
        'taxable_amount': 'taxableAmount',
        'tax_amount': 'taxAmount',
        'line_items': 'lineItems',
        'tax_details': 'taxDetails',
        'amount_details': 'amountDetails'
    }

    def __init__(self, exempt_amount=None, taxable_amount=None, tax_amount=None, line_items=None, tax_details=None, amount_details=None):
        """
        VasV2PaymentsPost201ResponseOrderInformation - a model defined in Swagger
        """

        self._exempt_amount = None
        self._taxable_amount = None
        self._tax_amount = None
        self._line_items = None
        self._tax_details = None
        self._amount_details = None

        if exempt_amount is not None:
          self.exempt_amount = exempt_amount
        if taxable_amount is not None:
          self.taxable_amount = taxable_amount
        if tax_amount is not None:
          self.tax_amount = tax_amount
        if line_items is not None:
          self.line_items = line_items
        if tax_details is not None:
          self.tax_details = tax_details
        if amount_details is not None:
          self.amount_details = amount_details

    @property
    def exempt_amount(self):
        """
        Gets the exempt_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        Total amount of tax exempt amounts. This value is the sum of the values for all the `orderInformation.lineItems[].exemptAmount` fields in the tax calculation request. 

        :return: The exempt_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        :rtype: str
        """
        return self._exempt_amount

    @exempt_amount.setter
    def exempt_amount(self, exempt_amount):
        """
        Sets the exempt_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        Total amount of tax exempt amounts. This value is the sum of the values for all the `orderInformation.lineItems[].exemptAmount` fields in the tax calculation request. 

        :param exempt_amount: The exempt_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        :type: str
        """

        self._exempt_amount = exempt_amount

    @property
    def taxable_amount(self):
        """
        Gets the taxable_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        Total amount of all taxable amounts. This value is the sum of the values for all the `orderInformation.lineItems[].taxAmount` fields in the tax calculation request. 

        :return: The taxable_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        :rtype: str
        """
        return self._taxable_amount

    @taxable_amount.setter
    def taxable_amount(self, taxable_amount):
        """
        Sets the taxable_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        Total amount of all taxable amounts. This value is the sum of the values for all the `orderInformation.lineItems[].taxAmount` fields in the tax calculation request. 

        :param taxable_amount: The taxable_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        :type: str
        """

        self._taxable_amount = taxable_amount

    @property
    def tax_amount(self):
        """
        Gets the tax_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        Total amount of tax for all lineItems in the tax calculation request. 

        :return: The tax_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        :rtype: str
        """
        return self._tax_amount

    @tax_amount.setter
    def tax_amount(self, tax_amount):
        """
        Sets the tax_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        Total amount of tax for all lineItems in the tax calculation request. 

        :param tax_amount: The tax_amount of this VasV2PaymentsPost201ResponseOrderInformation.
        :type: str
        """

        self._tax_amount = tax_amount

    @property
    def line_items(self):
        """
        Gets the line_items of this VasV2PaymentsPost201ResponseOrderInformation.

        :return: The line_items of this VasV2PaymentsPost201ResponseOrderInformation.
        :rtype: list[VasV2PaymentsPost201ResponseOrderInformationLineItems]
        """
        return self._line_items

    @line_items.setter
    def line_items(self, line_items):
        """
        Sets the line_items of this VasV2PaymentsPost201ResponseOrderInformation.

        :param line_items: The line_items of this VasV2PaymentsPost201ResponseOrderInformation.
        :type: list[VasV2PaymentsPost201ResponseOrderInformationLineItems]
        """

        self._line_items = line_items

    @property
    def tax_details(self):
        """
        Gets the tax_details of this VasV2PaymentsPost201ResponseOrderInformation.

        :return: The tax_details of this VasV2PaymentsPost201ResponseOrderInformation.
        :rtype: list[VasV2PaymentsPost201ResponseOrderInformationTaxDetails]
        """
        return self._tax_details

    @tax_details.setter
    def tax_details(self, tax_details):
        """
        Sets the tax_details of this VasV2PaymentsPost201ResponseOrderInformation.

        :param tax_details: The tax_details of this VasV2PaymentsPost201ResponseOrderInformation.
        :type: list[VasV2PaymentsPost201ResponseOrderInformationTaxDetails]
        """

        self._tax_details = tax_details

    @property
    def amount_details(self):
        """
        Gets the amount_details of this VasV2PaymentsPost201ResponseOrderInformation.

        :return: The amount_details of this VasV2PaymentsPost201ResponseOrderInformation.
        :rtype: Ptsv2paymentsidreversalsReversalInformationAmountDetails
        """
        return self._amount_details

    @amount_details.setter
    def amount_details(self, amount_details):
        """
        Sets the amount_details of this VasV2PaymentsPost201ResponseOrderInformation.

        :param amount_details: The amount_details of this VasV2PaymentsPost201ResponseOrderInformation.
        :type: Ptsv2paymentsidreversalsReversalInformationAmountDetails
        """

        self._amount_details = amount_details

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, VasV2PaymentsPost201ResponseOrderInformation):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
